#include <stdio.h>
#include <stdlib.h>
#include <sys/syscall.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#include <fcntl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>

//#include "Rvs_osd.h"

int _sdl_init(void);
void _sdl_dest(void);
void _sdl_txt_print(char *msg);
void _sdl_txt_del(void);


 SDL_Surface *screen;
 SDL_Surface *btsu;
 TTF_Font *font;

//------------------------------------------------------------------------------
void _sdl_dest(void)
{
   TTF_CloseFont(font);
   SDL_Quit();
}
//------------------------------------------------------------------------------
int _sdl_init(void)
{

   char *fpath="./shadow.ttf";
   struct stat sts;
   int fsize;

   if(stat(fpath, &sts) != 0)
     {
      //font not found
           return(1);
     }
   if(SDL_Init(SDL_INIT_VIDEO) != 0)
     {
      //initialisation fail
      return(2);
     }

   screen=SDL_SetVideoMode(1920/2, 1080/2, 32, SDL_HWSURFACE);
   if(screen == NULL)
     {
      //surface not opened
      return(3);
     }

   if(fsize == 0)
      {
       fsize=26; //Font size
      }
   if((TTF_Init() != 0) || ((font=TTF_OpenFont(fpath, fsize)) == NULL))
      {
       //font bad or damaged
       SDL_Quit();
       return(4);
      }

  return 0;
}

//------------------------------------------------------------------------------
void _sdl_txt_del(void)
{
 _sdl_txt_print("                                                                                                                                      ");//empty lines to delete
}
//------------------------------------------------------------------------------
void _sdl_txt_print(char *msg)
{
   SDL_Color c_black={ 0, 0, 0 };
   SDL_Color c_yellow={ 255, 255, 0 };
   SDL_Rect dstrect = { 20, 20, 0, 0 };

   btsu=TTF_RenderUTF8_Shaded(font, msg, c_yellow, c_black);
   SDL_BlitSurface(btsu, NULL, screen, &dstrect);//draw on the screen

   SDL_FreeSurface(btsu);  //remove surface before exit //!!!!!!!
   SDL_Flip(screen);
}
//------------------------------------------------------------------------------
int Game_Main(char *path, char *udn)
{
	char cmd[200];//, mtxt[200];
        int stop=1;

        struct stat sts;

         chdir(path); //change path to current
        _sdl_init();

        _sdl_txt_print("Wait . . . ");

	sprintf(cmd, "./dm.sh %s &", path);        //execute bash script
	system(cmd);

    while(stop==1)
       {
    if(!stat("/mtd_swu/no_usb", &sts))
        {
		_sdl_txt_del();
		_sdl_txt_print("Error: no USB found. . .");
		system("rm -rf /mtd_swu/no_usb");
        }

    if(!stat("/mtd_swu/1_ok", &sts))
        {
        _sdl_txt_del();
        _sdl_txt_print("Dumped: 5 %");
		system("rm -rf /mtd_swu/1_ok");
        }

    if(!stat("/mtd_swu/2_ok", &sts))
        {
        _sdl_txt_del();
        _sdl_txt_print("Dumped: 10 %");
		system("rm -rf /mtd_swu/2_ok");
		}	
		
		
	if(!stat("/mtd_swu/3_ok", &sts))
        {
		_sdl_txt_del();
        _sdl_txt_print("Dumped: 15 %");
		system("rm -rf /mtd_swu/3_ok");
        }		

	if(!stat("/mtd_swu/4_ok", &sts))
        {
		_sdl_txt_del();
        _sdl_txt_print("Dumped: 20 %");
		system("rm -rf /mtd_swu/4_ok");
        }		

    if(!stat("/mtd_swu/5_start", &sts))
        {
         _sdl_txt_del();
         _sdl_txt_print("Wait . . .");
		system("rm -rf /mtd_swu/5_start");
        }		
		
	if(!stat("/mtd_swu/5_ok", &sts))
        {
		_sdl_txt_del();
        _sdl_txt_print("Dumped: 35 %");
		system("rm -rf /mtd_swu/5_ok");
        }		
		
    if(!stat("/mtd_swu/6_start", &sts))
        {
        _sdl_txt_del();
        _sdl_txt_print("Wait . . .");
        system("rm -rf /mtd_swu/6_start");
		}		

    if(!stat("/mtd_swu/6_ok", &sts))
        {
        _sdl_txt_del();
        _sdl_txt_print("Dumped: 50 %");
        system("rm -rf /mtd_swu/6_ok");
		}		

    if(!stat("/mtd_swu/7_start", &sts))
        {
        _sdl_txt_del();
        _sdl_txt_print("Wait . . .");
		system("rm -rf /mtd_swu/7_start");
        }		

    if(!stat("/mtd_swu/7_ok", &sts))
        {
        _sdl_txt_del();
        _sdl_txt_print("Dumped: 65 %");
		system("rm -rf /mtd_swu/7_ok");
        }		
		
    if(!stat("/mtd_swu/8_start", &sts))
        {
        _sdl_txt_del();
        _sdl_txt_print("Wait . . .");
		system("rm -rf /mtd_swu/8_start");
        }		

    if(!stat("/mtd_swu/8_ok", &sts))
        {
        _sdl_txt_del();
        _sdl_txt_print("Dumped: 85 %");
		system("rm -rf /mtd_swu/8_ok");
        }		
		
    if(!stat("/mtd_swu/9_start", &sts))
        {
        _sdl_txt_del();
        _sdl_txt_print("Wait . . .");
		system("rm -rf /mtd_swu/9_start");
        }		

    if(!stat("/mtd_swu/9_ok", &sts))
        {
        _sdl_txt_del();
        _sdl_txt_print("Dumped: 100 %");
		system("rm -rf /mtd_swu/9_ok");
        }		
		
				
	if(!stat("/mtd_swu/end", &sts))
        {
        _sdl_txt_del();
        _sdl_txt_print("Finished.");
		usleep(1000*2000);

//		_sdl_txt_del();
//        _sdl_txt_print("Rebooting . . .");
//		usleep(1000*2000);
//		system("rm -rf /mtd_swu/end");
       }

    if(!stat("/mtd_swu/stop", &sts))
       {
          stop=0; //stop for exit!!!
         _sdl_txt_del();
         _sdl_txt_print("Stop ! ! !");
		system("rm -rf /mtd_swu/stop");
        }
       }

     _sdl_dest();

      return 0;
}
//------------------------------------------------------------------------------

